const express = require('express');
const Bourne = require('Bourne');
const path = require('path');
const logger = require('morgan');

var app = express();
var posts = new Bourne('posts.json');
var comments = new Bourne('comments.json');

app.use(logger('dev'));
app.use(express.json());
app.use(express.static('build'));

app.get('/posts', function (req, res) {
  posts.find(function (err, posts) {
    res.json(posts);
  });
});

app.post('/posts', function (req, res) {
  posts.insert(req.body, function (err, post) {
    res.json(post);
  });
});

app.get('/posts/:id/comments', function (req, res) {
  comments.find(
    { postId: parseInt(req.params.id, 10) },
    function (err, comments) {
      res.json(comments);
    }
  );
});

app.post('/posts/:id/comments', function (req, res) {
  comments.insert(req.body, function (err, comment) {
    res.json(comment);
  });
});

app.get('/*', function (req, res) {
  posts.find(function (err, posts) {
    res.render('index.ejs');
  });
});

app.listen(3000);
