import * as _ from 'underscore';

export function props(value) {
    return function decorator(target) {
        _.extend(target.prototype, value);
    }
}

export function defaults(value) {
  return function (target) {
    target.prototype.defaults = value;
  }
}

export function model(value) {
  return function (target) {
    target.prototype.model = value;
  }
}

export function url(value) {
  return function (target) {
    target.prototype.url = value;
  }
}

export function tagName(value) {
  return function (target) {
    target.prototype.tagName = value;
  }
}

export function template(value) {
  return function (target) {
    target.prototype.template = _.template(value);
  }
}

export function on(eventName){
  return function(target, name, descriptor){
    if(!target.events) {
        target.events = {};
    }
    if(_.isFunction(target.events)) {
        throw new Error('The on decorator is not compatible with an events method');
        return;
    }
    if(!eventName) {
        throw new Error('The on decorator requires an eventName argument');
    }
    target.events[eventName] = name;
    return descriptor;
  }
}
